SystemOrganization addCategory: #'CTM-Core'!
SystemOrganization addCategory: #'CTM-Example'!

Object subclass: #CTMEventListener
	instanceVariableNames: 'methodManagement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTM-Core'!

CTMEventListener class
	instanceVariableNames: 'instance'!

CTMEventListener class
	instanceVariableNames: 'instance'!

!CTMEventListener class methodsFor: 'as yet unclassified' stamp: 'mig 12/8/2010 20:35'!
instance

	^ instance ifNil: [ instance := self new ]! !

!CTMEventListener methodsFor: 'as yet unclassified' stamp: 'SR 1/6/2011 21:37'!
event: anEvent

	(anEvent itemKind == #method) ifTrue: [ self methodEvent: anEvent ].! !

!CTMEventListener methodsFor: 'as yet unclassified' stamp: 'SR 1/7/2011 13:20'!
methodEvent: anEvent

	| pragmas method |
	method := self methodManagement prepareMethod: anEvent item from: anEvent oldItem.
	
	pragmas := method pragmas.
	pragmas do: [ :pragma |
		CTMThing allSubclassesDo: [:class | | instance |
			instance := class new.
			(instance matchMethodPragma: pragma) ifTrue: [instance handleMethodEvent: anEvent]]].
	

! !

!CTMEventListener methodsFor: 'as yet unclassified' stamp: 'SR 1/7/2011 11:53'!
methodManagement

	^ methodManagement ifNil: [ methodManagement := CTMMethodManagement new]! !

!CTMEventListener methodsFor: 'as yet unclassified' stamp: 'mig 12/9/2010 20:12'!
register

	SystemChangeNotifier uniqueInstance notify: self ofAllSystemChangesUsing: #event:! !

!CTMEventListener methodsFor: 'as yet unclassified' stamp: 'mig 12/9/2010 20:13'!
unregister

	SystemChangeNotifier uniqueInstance noMoreNotificationsFor: self! !

Object subclass: #CTMMethodManagement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTM-Core'!

!CTMMethodManagement methodsFor: 'generated-method-handling' stamp: 'SR 1/7/2011 13:20'!
addGeneratedMethodFor: aCompiledMethod with: aCodeString

	| class method generatedMethods |
	class := aCompiledMethod methodClass.
	method := self addMethodTo: class in: #generated with: aCodeString.
	method ifNil: [ ^ nil ].
	
	"Mark new method as generated method"
	method isCTMGeneratedMethod: true.
	
	"Add new method to generated methods list"
	generatedMethods := aCompiledMethod ctmGeneratedMethodsForThis.
	(generatedMethods contains: [:i | i = method selector]) ifFalse: [generatedMethods add: (method selector)].
	aCompiledMethod ctmGeneratedMethodsForThis: generatedMethods.! !

!CTMMethodManagement methodsFor: 'normal-method-handling' stamp: 'SR 1/7/2011 11:47'!
addMethodTo: aClass in: aCategorySymbol with: aCodeString

	| methodAndNode selector |
	methodAndNode := aClass compile: aCodeString classified: aCategorySymbol notifying: nil trailer: aClass defaultMethodTrailer ifFail: [^nil].
	selector := methodAndNode selector.
	
	(aClass methodDictionary includesKey: selector) ifTrue: [
		(aClass>>selector) isCTMGeneratedMethod ifTrue: [ ^ nil ].
	].

	aClass addAndClassifySelector: selector withMethod: methodAndNode method inProtocol: aCategorySymbol notifying: nil.
	^ methodAndNode method! !

!CTMMethodManagement methodsFor: 'as yet unclassified' stamp: 'SR 1/7/2011 13:18'!
copyCTMPropertiesFrom: anOldCompiledMethod to: aCompiledMethod
	
	aCompiledMethod isCTMGeneratedMethod: (anOldCompiledMethod isCTMGeneratedMethod).
	aCompiledMethod ctmGeneratedMethodsForThis: (anOldCompiledMethod ctmGeneratedMethodsForThis).! !

!CTMMethodManagement methodsFor: 'as yet unclassified' stamp: 'SR 1/7/2011 13:17'!
prepareMethod: aCompiledMethod from: anOldCompiledMethod

	"Copy our properties from the old method to the new one"
	anOldCompiledMethod ifNotNil: [self copyCTMPropertiesFrom: anOldCompiledMethod to: aCompiledMethod].
	
	"Cleanup generated methods"
	self removeAllGeneratedMethodsFor: aCompiledMethod.
	^ aCompiledMethod methodClass compiledMethodAt: (aCompiledMethod selector) ifAbsent: [ "The method is not in the method dict, so this was caused by an remove event" aCompiledMethod ]! !

!CTMMethodManagement methodsFor: 'generated-method-handling' stamp: 'SR 1/7/2011 13:16'!
removeAllGeneratedMethodsFor: aCompiledMethod

	| class |
	class := aCompiledMethod methodClass.
	
	aCompiledMethod ctmGeneratedMethodsForThis do: [ :methodSelector |
		(class methodDictionary includesKey: methodSelector) ifTrue: [
			self removeMethod: (class>>methodSelector)]].

	aCompiledMethod ctmGeneratedMethodsForThis: (OrderedCollection new).! !

!CTMMethodManagement methodsFor: 'normal-method-handling' stamp: 'SR 1/7/2011 11:06'!
removeMethod: aCompiledMethod

	| class selector |
	class := aCompiledMethod methodClass.
	selector := aCompiledMethod selector.
	
	self removeAllGeneratedMethodsFor: aCompiledMethod.
	class removeSelector: selector.! !

Object subclass: #CTMThing
	instanceVariableNames: 'methodManagement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTM-Core'!

CTMThing subclass: #CTMOptionalParameterThing
	instanceVariableNames: 'config'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTM-Core'!

!CTMOptionalParameterThing methodsFor: 'as yet unclassified' stamp: 'SR 1/7/2011 13:37'!
config

	^ config ifNil: [ config := Dictionary new].! !

!CTMOptionalParameterThing methodsFor: 'as yet unclassified' stamp: 'SR 1/7/2011 13:42'!
matchMethodPragma: aPragma

	(aPragma keyword asString matchesRegex: '^(optional\:default\:)*$') ifTrue: [
		1 to: (aPragma arguments size / 2) do: [:i | | key value |
			key := aPragma argumentAt: ((i*2)-1).
			value := aPragma argumentAt: (i*2).
			self config at: key put: value].
		^ true].
	
	^ super matchMethodPragma: aPragma! !

!CTMOptionalParameterThing methodsFor: 'as yet unclassified' stamp: 'SR 1/7/2011 14:25'!
methodAdded: aMethod in: aClass

	self config keys allCombinationsDo: [:each | | signature difference signatureParts callParts code call |
		difference := aMethod selectorParts difference: each.
		signatureParts := difference collectWithIndex: [ :each2 :index | '{1} t{2}' format: {each2 asString. index asString.}].
		signature := signatureParts inject: '' into: [:subTotal :next | '{1} {2}' format: {subTotal. next.}].
		
		callParts := aMethod selectorParts collect: [:each2 | (self config includesKey: each2)
				ifTrue: ['{1} {2}' format: {each2. self config at: each2.}]
				ifFalse: ['{1} t{2}' format: {each2. difference indexOf: each2.}]].
		call := callParts inject: '' into: [:subTotal :next | '{1} {2}' format: {subTotal. next.}].
		
		code := '{1}

^ self {2}' format: {signature. call.}.
		self methodManagement addGeneratedMethodFor: aMethod with: code
	].! !

CTMThing subclass: #CTMShortcutsThing
	instanceVariableNames: 'shortcutName shortcutMaxCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTM-Core'!

!CTMShortcutsThing methodsFor: 'pragma-matching' stamp: 'SR 1/6/2011 21:50'!
matchMethodPragma: aPragma

	(aPragma keyword = #shortcuts:count:) ifTrue: [
		shortcutName := aPragma argumentAt: 1.
		shortcutMaxCount := aPragma argumentAt: 2.
		^ true].
	
	^ super matchMethodPragma: aPragma! !

!CTMShortcutsThing methodsFor: 'method-events' stamp: 'SR 1/7/2011 13:15'!
methodAdded: aMethod in: aClass
	
	| methodName collectionCreation |
	methodName := ''.
	collectionCreation := 'array := OrderedCollection new'.
	
	1 to: shortcutMaxCount do: [ :i | | code |
		methodName := '{1} {2}: aValue{3}' format: {methodName. shortcutName. i. }.
		collectionCreation := '{1} add: aValue{2}; ' format: {collectionCreation. i.}.
		
		code := '{1}
| array |
{2}yourself.
^ self {3} array' format: {methodName. collectionCreation. aMethod selector. }.
		self methodManagement addGeneratedMethodFor: aMethod with: code.
	].! !

!CTMThing class methodsFor: 'as yet unclassified' stamp: 'SR 1/6/2011 21:59'!
convertModifiedToAddedRemoved

	^ true! !

!CTMThing methodsFor: 'internal' stamp: 'SR 1/6/2011 21:57'!
handleMethodEvent: anEvent

	| class method |
	method := anEvent item.
	class := anEvent environmentAt: #class.

	anEvent isAdded ifTrue: [ ^ self methodAdded: method in: class ].
	anEvent isModified ifTrue: [ ^ self methodModified: method in: class from: (anEvent oldItem) ].
	anEvent isRemoved ifTrue: [ ^ self methodRemoved: method in: class ].! !

!CTMThing methodsFor: 'pragma-matching' stamp: 'SR 1/6/2011 22:03'!
matchClassPragma: aPragma

	^ false! !

!CTMThing methodsFor: 'pragma-matching' stamp: 'SR 1/6/2011 21:25'!
matchMethodPragma: aPragma

	^ false! !

!CTMThing methodsFor: 'method-events' stamp: 'SR 1/6/2011 21:32'!
methodAdded: aMethod in: aClass
! !

!CTMThing methodsFor: 'as yet unclassified' stamp: 'SR 1/6/2011 22:03'!
methodManagement

	^ methodManagement ifNil: [ methodManagement := CTMMethodManagement new].! !

!CTMThing methodsFor: 'method-events' stamp: 'SR 1/6/2011 22:00'!
methodModified: aMethod in: aClass from: anOldMethod

	self class convertModifiedToAddedRemoved ifTrue: [
		self methodRemoved: anOldMethod in: aClass.
		self methodAdded: aMethod in: aClass]! !

!CTMThing methodsFor: 'method-events' stamp: 'SR 1/6/2011 21:38'!
methodRemoved: aMethod in: aClass! !

Object subclass: #Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTM-Example'!

!SequenceableCollection methodsFor: '*CTM-Core' stamp: 'SR 1/7/2011 13:49'!
allCombinationsDo: aBlock

	1 to: self size do: [:i | self combinations: i atATimeDo: aBlock]! !

!AbstractEvent methodsFor: '*CTM-Core' stamp: 'SR 1/7/2011 13:19'!
oldItem

	^ nil! !

!CompiledMethod methodsFor: '*CTM-Core' stamp: 'SR 1/7/2011 11:00'!
ctmGeneratedMethodsForThis

	^ self propertyValueAt: #cmtGenerated ifAbsent: [OrderedCollection new].! !

!CompiledMethod methodsFor: '*CTM-Core' stamp: 'SR 1/7/2011 11:00'!
ctmGeneratedMethodsForThis: aCollection

	^ self propertyValueAt: #cmtGenerated put: aCollection.! !

!CompiledMethod methodsFor: '*CTM-Core' stamp: 'SR 1/7/2011 13:05'!
isCTMGeneratedMethod

	^ self propertyValueAt: #ctmGenerated ifAbsent: [false]! !

!CompiledMethod methodsFor: '*CTM-Core' stamp: 'SR 1/7/2011 13:05'!
isCTMGeneratedMethod: aBoolean

	^ self propertyValueAt: #ctmGenerated put: aBoolean! !

!CompiledMethod methodsFor: '*CTM-Core' stamp: 'SR 1/7/2011 13:56'!
selectorParts

	^ (self selector asString subStrings: ':') collect: [:each | (each,':') asSymbol]! !
